## upx-ucl 3.94

=== Makefile ===
#
# UPX toplevel Makefile - needs GNU make 3.81 or better
#
# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
#

MAKEFLAGS += -rR
.SUFFIXES:
export SHELL = /bin/sh

srcdir = .
top_srcdir = .
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)

# info: src/stub needs special build tools from https://github.com/upx/upx-stubtools
BUILD_STUB = 0
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/upx-stubtools-check-version),)
BUILD_STUB = 1
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/upx-stubtools-check-version),)
BUILD_STUB = 1
endif

default:
	@echo "UPX info: please choose a target for 'make'"

all mostlyclean clean distclean maintainer-clean:
ifeq ($(BUILD_STUB),1)
	$(MAKE) -C src/stub $@
endif
	$(MAKE) -C src $@
	$(MAKE) -C doc $@

.PHONY: default all mostlyclean clean distclean maintainer-clean

# vim:set ts=8 sw=8 noet:

=== doc/Makefile ===
#
# UPX doc Makefile - needs GNU make 3.81 or better
#

MAKEFLAGS += -rR
.SUFFIXES:
SHELL = /bin/sh

# internal make variables
comma := ,
empty :=
space := $(empty) $(empty)
tab   := $(empty)	$(empty)


# /***********************************************************************
# //
# ************************************************************************/

top_srcdir ?= ..

PACKAGE       = upx
VERSION_DATE := $(shell sed -n 's/^.*UPX_VERSION_DATE_ISO .*"\(.*\)".*/\1/p' $(top_srcdir)/src/version.h)
VERSION      := $(shell sed -n 's/^.*UPX_VERSION_STRING .*"\(.*\)".*/\1/p' $(top_srcdir)/src/version.h)

RTRIM  := sed -e 's/[ $(tab)]*$$//'
DETAB2 := sed -e 's/$(tab)/  /g'

BUILT_SOURCES = upx.1 upx.doc upx.html upx.man upx.ps upx.tex
BUILT_SOURCES = upx.1 upx.doc upx.html


###
### targets
###

all: $(BUILT_SOURCES)

mostlyclean clean distclean maintainer-clean:
	rm -f $(BUILT_SOURCES) pod2htm*

.PHONY: all mostlyclean clean distclean maintainer-clean


###
### rules
###

.SUFFIXES: .1 .doc .html .man .pod .ps .tex

%.1 : %.pod
	pod2man --center=" " --release="$(PACKAGE) $(VERSION)" --date="$(VERSION_DATE)" $< | $(RTRIM) > $@

%.doc : %.pod
	pod2text < $< | $(RTRIM) > $@

%.html : %.pod
	pod2html --noindex $< | $(RTRIM) | $(DETAB2) > $@
	@rm -f pod2htm*

%.man : %.1
	nroff -man $< | $(RTRIM) > $@

%.ps : %.1
	groff -man $< | $(RTRIM) > $@

%.tex : %.pod
	pod2latex $<


###
### dependencies
###

$(BUILT_SOURCES): $(top_srcdir)/src/version.h $(MAKEFILE_LIST)
.DELETE_ON_ERROR: $(BUILT_SOURCES)

=== src/Makefile ===
#
# UPX Makefile - needs GNU make 3.81 or better
#
# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
#

# build configuration options for this Makefile
BUILD_TYPE_DEBUG    ?= 0
BUILD_TYPE_SANITIZE ?= 0
BUILD_USE_DEPEND    ?= 1

MAKEFLAGS += -r
.SUFFIXES:
export SHELL = /bin/sh
override ee = $($1) $(EXTRA_$1) $(upx_$1) $(upx_EXTRA_$1) $($(basename $(notdir $@)).$1)

ifndef srcdir
srcdir := $(dir $(lastword $(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,' || echo 'ERROR')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)
ifneq ($(srcdir),.)
vpath %.cpp .:$(srcdir)
vpath %.h   .:$(srcdir)
endif

# toolchain
CXX    ?= g++
CXXLD   = $(CXX)
exeext ?= .out
libext ?= .a
objext ?= .o

upx_SOURCES := $(sort $(wildcard $(srcdir)/*.cpp))
upx_OBJECTS := $(notdir $(upx_SOURCES:.cpp=$(objext)))

ifneq ($(wildcard $(top_srcdir)/.git/.),)
UPX_VERSION_GITREV := $(strip $(shell cd '$(top_srcdir)' && git rev-parse --short=12 HEAD || echo 'ERROR'))
ifneq ($(UPX_VERSION_GITREV),)
GITREV_PLUS := $(strip $(shell cd '$(top_srcdir)' && git diff --exit-code HEAD >/dev/null && echo '' || echo '+'))
DEFS += '-DUPX_VERSION_GITREV="$(UPX_VERSION_GITREV)$(GITREV_PLUS)"'
endif
endif

# we need UCL and zlib - you can set envvar UPX_UCLDIR
ifneq ($(wildcard $(UPX_UCLDIR)/include/ucl/ucl.h),)
INCLUDES += -I$(UPX_UCLDIR)/include
LIBS += $(addprefix -L,$(dir $(wildcard $(UPX_UCLDIR)/libucl$(libext) $(UPX_UCLDIR)/src/.libs/libucl$(libext))))
endif
LIBS += -lucl -lz
# LZMA from https://github.com/upx/upx-lzma-sdk
include $(top_srcdir)/src/stub/src/c/Makevars.lzma

CPPFLAGS += $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES)
ifeq ($(BUILD_TYPE_DEBUG),1)
CXXFLAGS_OPTIMIZE ?= -O0 -g
else
CXXFLAGS_OPTIMIZE ?= -O2
endif
CXXFLAGS += $(CXXFLAGS_OPTIMIZE)
# protect against security threats caused by misguided C++ compiler "optimizations"
ifeq ($(findstring clang,$(CXX)),)
CXXFLAGS += -fno-delete-null-pointer-checks
endif
CXXFLAGS += -fno-strict-aliasing -fwrapv
CXXFLAGS += -funsigned-char
CXXFLAGS += -Wall -W -Wcast-align -Wcast-qual -Wmissing-declarations -Wpointer-arith -Wshadow -Wvla -Wwrite-strings
CXXFLAGS_WERROR ?= -Werror
CXXFLAGS += $(CXXFLAGS_WERROR)

ifeq ($(BUILD_TYPE_SANITIZE),1)
CXXFLAGS_SANITIZE ?= -fsanitize=address,undefined -fno-omit-frame-pointer -DACC_CFG_NO_UNALIGNED
CXXFLAGS += $(CXXFLAGS_SANITIZE)
# these are the only 2 objects that are actually speed-sensitive
compress_lzma$(objext) filteri$(objext) : override CXXFLAGS_SANITIZE =
endif

# rules
all: upx$(exeext) | ./.depend
.DELETE_ON_ERROR: upx$(exeext) $(upx_OBJECTS) ./.depend

upx$(exeext): $(upx_OBJECTS) $(upx_DEPENDENCIES)
	$($(notdir $@).PRE_LINK_STEP)
	$(strip $(CXXLD) $(call ee,CXXFLAGS) $(call ee,LDFLAGS) -o $@ $(upx_OBJECTS) $(call ee,LDADD) $(call ee,LIBS))
	$($(notdir $@).POST_LINK_STEP)
	$(CHECK_WHITESPACE)

%.o : %.cpp | ./.depend
	$(strip $(CXX) $(call ee,CPPFLAGS) $(call ee,CXXFLAGS) -o $@ -c $<)
%.cpp.ii : %.cpp
	$(strip $(CXX) $(call ee,CPPFLAGS) $(call ee,CXXFLAGS) -o $@ -E $<)

ifeq ($(BUILD_USE_DEPEND),1)
./.depend: $(sort $(wildcard $(srcdir)/*.cpp $(srcdir)/*.h)) $(MAKEFILE_LIST)
	@rm -f $@
	@echo "Updating $@"
	@$(strip $(CXX) $(call ee,CPPFLAGS) $(call ee,CXXFLAGS) -MM) $(filter %.cpp,$^) > $@
else
./.depend:
.PHONY: ./.depend
endif

CHECK_WHITESPACE =
ifeq ($(shell uname),Linux)
CHECK_WHITESPACE = $(top_srcdir)/src/stub/scripts/check_whitespace.sh $(top_srcdir)
ifneq ($(wildcard $(top_srcdir)/.git/.),)
CHECK_WHITESPACE = $(top_srcdir)/src/stub/scripts/check_whitespace_git.sh $(top_srcdir)
endif
check-whitespace : ; $(CHECK_WHITESPACE)
endif
.PHONY: check-whitespace

mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.ii *.map *.o *.obj *.res ./.depend upx.exe upx.out upx.ttp upx$(exeext)

./.depend compress_lzma$(objext) : INCLUDES += -I$(UPX_LZMADIR)

compress_lzma$(objext) : CXXFLAGS += -Wno-shadow
p_mach$(objext)        : CXXFLAGS += -Wno-cast-align

.PHONY: all mostlyclean clean distclean maintainer-clean

ifeq ($(MAKECMDGOALS),mostlyclean)
else ifeq ($(MAKECMDGOALS),clean)
else ifeq ($(MAKECMDGOALS),distclean)
else ifeq ($(MAKECMDGOALS),maintainer-clean)
else ifeq ($(MAKECMDGOALS),clang-format)
else ifeq ($(MAKECMDGOALS),check-whitespace)
else
ifeq ($(BUILD_USE_DEPEND),1)
-include ./.depend
endif
help$(objext): $(MAKEFILE_LIST)
endif

# "make run-testsuite"
# search for the UPX testsuite -- git clone https://github.com/upx/upx-testsuite.git
# you also can override upx_testsuite_SRCDIR
ifndef upx_testsuite_SRCDIR
# search standard locations below $(top_srcdir)
ifneq ($(wildcard $(top_srcdir)/../upx-testsuite.git/files/packed/.),)
upx_testsuite_SRCDIR := $(top_srcdir)/../upx-testsuite.git
else ifneq ($(wildcard $(top_srcdir)/../upx-testsuite/files/packed/.),)
upx_testsuite_SRCDIR := $(top_srcdir)/../upx-testsuite
endif
endif
# run the UPX testsuite
# The expected (old) checksums are in $(top_srcdir)/.github/travis_testsuite_1.sh
# The   actual (new) checksums are in tmp-testsuite/testsuite_1/.sha256sums.recreate
ifneq ($(wildcard $(upx_testsuite_SRCDIR)/files/packed/.),)
ifneq ($(wildcard $(top_srcdir)/.github/travis_testsuite_1.sh),)
run-testsuite: export upx_exe                := ./upx$(exeext)
run-testsuite: export upx_testsuite_SRCDIR   := $(upx_testsuite_SRCDIR)
run-testsuite: export upx_testsuite_BUILDDIR := ./tmp-testsuite
run-testsuite: ./upx$(exeext)
	time -p bash $(top_srcdir)/.github/travis_testsuite_1.sh
.PHONY: run-testsuite
endif
endif

# automatically format some C++ source code files
ifeq ($(shell uname),Linux)
CLANG_FORMAT_FILES += linker.cpp linker.h packhead.cpp packmast.cpp
CLANG_FORMAT_FILES += s_djgpp2.cpp s_object.cpp s_vcsa.cpp s_win32.cpp screen.h
CLANG_FORMAT_FILES += snprintf.cpp
CLANG_FORMAT_FILES += stdcxx.cpp stdcxx.h
CLANG_FORMAT_FILES += ui.cpp ui.h util.h
clang-format:
	$(top_srcdir)/src/stub/scripts/upx-clang-format -i $(addprefix $(top_srcdir)/src/,$(CLANG_FORMAT_FILES))
.PHONY: clang-format
endif

# vim:set ts=8 sw=8 noet:

=== src/stub/Makefile ===
#
# UPX stub Makefile - needs GNU make 3.81 or better
#
# You also will need a number of special build tools like various
# cross-assemblers and cross-compilers - please see README.SRC
# for details.
#
# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
#

MAKEFLAGS += -rR
.SUFFIXES:
.SECONDEXPANSION:
.NOTPARALLEL:
export LC_ALL = C
export SHELL = /bin/sh

# internal make variables
comma := ,
empty :=
space := $(empty) $(empty)
tab   := $(empty)	$(empty)

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

ifndef srcdir
srcdir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/../..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)

# update $PATH for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
else ifneq ($(wildcard $(HOME)/.local/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/.local/bin/bin-upx:$(PATH)
else ifneq ($(wildcard $(HOME)/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif


# /***********************************************************************
# //
# ************************************************************************/

ifndef STUBS
STUBS += amd64-darwin.dylib-entry.h
STUBS += amd64-darwin.macho-entry.h
STUBS += amd64-darwin.macho-fold.h
STUBS += amd64-darwin.macho-upxmain.h
STUBS += amd64-linux.elf-entry.h
STUBS += amd64-linux.elf-fold.h
STUBS += amd64-linux.kernel.vmlinux-head.h
STUBS += amd64-linux.kernel.vmlinux.h
STUBS += amd64-linux.shlib-init.h
STUBS += amd64-win64.pep.h
STUBS += arm.v4a-linux.elf-entry.h
STUBS += arm.v4a-linux.elf-fold.h
STUBS += arm.v4a-wince.pe.h
STUBS += arm.v4t-wince.pe.h
STUBS += arm.v5a-darwin.macho-entry.h
STUBS += arm.v5a-darwin.macho-fold.h
STUBS += arm.v5a-linux.elf-entry.h
STUBS += arm.v5a-linux.elf-fold.h
STUBS += arm.v5a-linux.kernel.vmlinux-head.h
STUBS += arm.v5a-linux.kernel.vmlinux.h
STUBS += arm.v5a-linux.kernel.vmlinuz-head.h
STUBS += arm.v5a-linux.kernel.vmlinuz.h
STUBS += arm.v5a-linux.shlib-init.h
STUBS += arm.v5t-linux.shlib-init.h
STUBS += armeb.v4a-linux.elf-entry.h
STUBS += armeb.v4a-linux.elf-fold.h
STUBS += armeb.v5a-linux.kernel.vmlinux-head.h
STUBS += armeb.v5a-linux.kernel.vmlinux.h
STUBS += arm64-linux.elf-entry.h
STUBS += arm64-linux.elf-fold.h
STUBS += arm64-linux.shlib-init.h
STUBS += arm64-darwin.macho-entry.h
STUBS += arm64-darwin.macho-fold.h
STUBS += i086-dos16.com.h
STUBS += i086-dos16.exe.h
STUBS += i086-dos16.sys.h
STUBS += i386-bsd.elf-entry.h
STUBS += i386-bsd.elf-fold.h
STUBS += i386-bsd.elf.execve-entry.h
STUBS += i386-bsd.elf.execve-fold.h
STUBS += i386-darwin.dylib-entry.h
# STUBS += i386-darwin.dylib-fold.h
STUBS += i386-darwin.macho-entry.h
STUBS += i386-darwin.macho-fold.h
STUBS += i386-darwin.macho-upxmain.h
STUBS += i386-dos32.djgpp2-stubify.h
STUBS += i386-dos32.djgpp2.h
STUBS += i386-dos32.tmt.h
STUBS += i386-dos32.watcom.le.h
STUBS += i386-linux.elf-entry.h
STUBS += i386-linux.elf-fold.h
STUBS += i386-linux.elf.execve-entry.h
STUBS += i386-linux.elf.execve-fold.h
STUBS += i386-linux.elf.interp-entry.h
STUBS += i386-linux.elf.interp-fold.h
STUBS += i386-linux.elf.shell-entry.h
STUBS += i386-linux.elf.shell-fold.h
STUBS += i386-linux.kernel.vmlinux-head.h
STUBS += i386-linux.kernel.vmlinux.h
STUBS += i386-linux.kernel.vmlinuz.h
STUBS += i386-linux.shlib-init.h
STUBS += i386-netbsd.elf-entry.h
STUBS += i386-netbsd.elf-fold.h
STUBS += i386-openbsd.elf-fold.h
STUBS += i386-win32.pe.h
STUBS += m68k-atari.tos.h
STUBS += mips.r3000-linux.elf-entry.h
STUBS += mips.r3000-linux.elf-fold.h
STUBS += mipsel.r3000-linux.elf-entry.h
STUBS += mipsel.r3000-linux.elf-fold.h
STUBS += mipsel.r3000-ps1.h
STUBS += powerpc-darwin.dylib-entry.h
STUBS += powerpc-darwin.macho-entry.h
STUBS += powerpc-darwin.macho-fold.h
STUBS += powerpc-darwin.macho-upxmain.h
STUBS += powerpc-linux.elf-entry.h
STUBS += powerpc-linux.elf-fold.h
STUBS += powerpc-linux.kernel.vmlinux-head.h
STUBS += powerpc-linux.kernel.vmlinux.h
STUBS += powerpc64le-darwin.dylib-entry.h
STUBS += powerpc64le-darwin.macho-entry.h
STUBS += powerpc64le-darwin.macho-fold.h
STUBS += powerpc64le-linux.elf-entry.h
STUBS += powerpc64le-linux.elf-fold.h
STUBS += powerpc64le-linux.kernel.vmlinux-head.h
STUBS += powerpc64le-linux.kernel.vmlinux.h
endif


ifndef default.targets
ifeq ($(wildcard .all-stamp),)
default.targets =
default:
	@echo "UPX info: type 'make all' if you have all the required build tools."
else
default.targets = all
default: $$(default.targets)
endif
endif


all.targets ?= .upx-stubtools-stamp tmp/.tmp-stamp .all-stamp
all: $$(all.targets)
.upx-stubtools-stamp: $(MAKEFILE_LIST)
	upx-stubtools-check-version 20160918
	@echo "timestamp" > $@
.DELETE_ON_ERROR: .upx-stubtools-stamp
%/.tmp-stamp:
	@mkdir -p $(dir $@)
	@echo "timestamp" > $@
.PRECIOUS: %/.tmp-stamp
.all-stamp: $$(STUBS)
	@echo "timestamp" > $@

ifeq ($(wildcard .all-stamp),)
mostlyclean clean: distclean
else
mostlyclean clean: maintainer-clean
endif
distclean:
	rm -f .*-stamp
	rm -rf tmp
maintainer-clean:
	rm -f .upx-stubtools-stamp
	rm -rf tmp
	rm -f $(STUBS)
list-stubs: $(STUBS)
#	@ls -l $(STUBS)
	@wc $(STUBS)

.PHONY: default all mostlyclean clean distclean maintainer-clean list-stubs


# util var for use in the rules - basename of the current target
override T = $(basename $(notdir $@))

# clear some vars, just in case
LABEL_PREFIX =
PP_FLAGS =
tc_bfdarch =
tc_bfdname =
tc_list =
tc_objdump_disasm_options =

# commands
ECHO_e     = /bin/echo -e
ECHO_E     = /bin/echo -E
PERL       = perl
PYTHON     = python
UNIX2DOS  := $(PERL) -i -pe 's/$$/\r/;'

# trim (strip) trailing whitespace
RTRIM     := sed -e 's/[ $(tab)]*$$//'
# squeeze duplicate blank lines, delete empty first & last line
BLSQUEEZE := $(RTRIM) | cat --squeeze-blank | sed -e '1{/^$$/d}' -e '$${/^$$/d}'
# delete blank lines
BLDEL     := $(RTRIM) | sed -e '/^$$/d'
# delete blank lines at top (beginning) of file
BLDELTOP  := sed -e '/./,$$!d'
# delete blank lines at bottom (end) of file
BLDELBOT  := sed -e ':a' -e '/^\n*$$/{$$d;N;ba' -e '}'


# /***********************************************************************
# // setup toolchain globals
# ************************************************************************/

# enumerate the names of all variables that will get tested (from basename and $(tc_list))
__tc_varlist   = tc.$(basename $(notdir $@)).$1 $(foreach v,$(tc_list),tc.$v.$1)
# return the name of the first variable that is not empty
__tc_varsearch = $(firstword $(foreach v,$1,$(if $($v),$v,)))
# error sentinel for missing commands
__tc_FALSE     = false tc_FALSE: '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
# call (expand) the first variable that is not empty
  # [move the next comment line within the "tc" macro for debugging]
  # tc debug '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
define tc
  $(call $(call __tc_varsearch,$(call __tc_varlist,$1) __tc_FALSE),$2,$3,$4,$5)
endef

# default tools
tc.default.bin2h      = $(PYTHON) $(top_srcdir)/src/stub/scripts/bin2h.py --ident=auto-stub
##tc.default.bin2h-c    = $(call tc,bin2h) --compress=14,15,0
tc.default.bin2h-c    = $(call tc,bin2h) --compress=0
tc.default.brandelf   = $(PYTHON) $(top_srcdir)/src/stub/scripts/brandelf.py $(if $(tc_bfdname),--bfdname=$(tc_bfdname))
tc.default.gpp_inc    = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py
tc.default.gpp_mkdep  = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py -o /dev/null
tc.default.pp-as      = i386-linux-gcc-3.4.6 -E -nostdinc -x assembler-with-cpp -Wall
tc.default.sstrip     = sstrip-20060518
tc.default.xstrip     = $(PYTHON) $(top_srcdir)/src/stub/scripts/xstrip.py

# default multiarch-binutils
tc.default.m-ar       = multiarch-ar-2.17
tc.default.m-ld       = multiarch-ld-2.17 $(if $(tc_bfdname),-b $(tc_bfdname))
tc.default.m-nm       = multiarch-nm-2.17 $(if $(tc_bfdname),--target=$(tc_bfdname))
tc.default.m-objcopy  = multiarch-objcopy-2.17 $(if $(tc_bfdname),-F $(tc_bfdname))
tc.default.m-objdump  = multiarch-objdump-2.17 $(if $(tc_bfdname),-b $(tc_bfdname)) $(if $(tc_bfdarch),-m $(tc_bfdarch))
tc.default.m-readelf  = multiarch-readelf-2.17

# default binutils
tc.default.ld         = $(call tc,m-ld)
tc.default.nm         = $(call tc,m-nm)
tc.default.objcopy    = $(call tc,m-objcopy)
tc.default.objdump    = $(call tc,m-objdump)
tc.default.readelf    = $(call tc,m-readelf)

# default binutils functions
define tc.default.f-embed_objinfo
	chmod a-x $1
	$(call tc,objcopy) --strip-unneeded $1
	$(call tc,objcopy) -R .text -R .data -R .bss $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
	$(call tc,objdump) -Dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
	$(call tc,objdump) -htr -w $1 | $(BLSQUEEZE) | sed -e '1s/^.*: *file format/file format/' > $1.dump
	$(call tc,xstrip) --with-dump=$1.dump $1
	cat $1.dump >> $1
endef

tc.default.f-objstrip-disasm.bin = @true
tc.default.f-objstrip-disasm.o   = $(call tc,objdump) -dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
tc.default.f-objstrip-disasm.obj = $(call tc,objdump) -dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
define tc.default.f-objstrip
	chmod a-x $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
	$(call tc,f-objstrip-disasm$(suffix $1),$1)
endef

# some common arch settings
tc.arch-i086.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i086.wdis     = $(WATCOM)/binl/wdis
tc.arch-i386.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i386.djasm    = djasm-20060614


# /***********************************************************************
# // amd64-darwin.dylib
# ************************************************************************/

# info: we use the tc settings from amd64-linux.elf
amd64-darwin.dylib%.h : tc_list = amd64-linux.elf default
amd64-darwin.dylib%.h : tc_bfdname = elf64-x86-64

## All code is in dylib-entry.  There is no dylib-fold, no dylib-main.
amd64-darwin.dylib-entry.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@


# /***********************************************************************
# // amd64-darwin.macho
# ************************************************************************/

# info: we use the tc settings from amd64-linux.elf
amd64-darwin.macho%.h : tc_list = amd64-linux.elf default
amd64-darwin.macho%.h : tc_bfdname = elf64-x86-64

amd64-darwin.macho-entry.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@

amd64-darwin.macho-fold.h : tmp/$$T.o tmp/amd64-darwin.macho-main.o
	$(call tc,ld) --no-warn-mismatch --strip-all --oformat binary -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	chmod a-x tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@

amd64-darwin.macho-upxmain.h: amd64-darwin.macho-upxmain.exe
	$(call tc,bin2h) $< $@

tmp/amd64-darwin.macho-fold.o : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o $@
	$(call tc,f-objstrip,$@)

tmp/amd64-darwin.macho-main.o : $(srcdir)/src/$$T.c
	$(call tc,gcc) -c -Os -fPIC $< -o $@
	$(call tc,f-objstrip,$@)


# /***********************************************************************
# // amd64-linux.elf
# ************************************************************************/

amd64-linux.elf%.h : tc_list = amd64-linux.elf default
amd64-linux.elf%.h : tc_bfdname = elf64-x86-64

tc.amd64-linux.elf.gcc  = amd64-linux-gcc-3.4.4 -m64 -nostdinc -MMD -MT $@
tc.amd64-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror

=== debian/changelog ===
upx-ucl (3.94-4) unstable; urgency=medium

  * Apply Mach-o-defend-against-bad-crafted-input.patch from upstream
    to fix crash on packing corrupted Mach-O file (CVE-2017-16869,
    closes: #882041).
  * Apply Protect-against-bad-crafted-input.patch from upstream to fix
    crashes found by AFL (CVE-2017-15056, closes: #873260).
  * Standards-Version: 4.1.2.

 -- Robert Luberda <robert@debian.org>  Fri, 22 Dec 2017 23:25:38 +0100

upx-ucl (3.94-3) unstable; urgency=medium

  * Note in README.source that upx uses upstream-provided LZMA library
    because lzma-dev package does not provide all the files necessary
    to build upx (closes: #871647).
  * Apply patch from Helmut Grohne to fix cross-compiling (closes: #871633):
    + let debhelper choose the correct CC;
    + fix build/host confusion;
    + ask dpkg for host endianness rather than maintaining a list.
  * Standards-Version: 4.1.0.

 -- Robert Luberda <robert@debian.org>  Fri, 01 Sep 2017 23:43:04 +0200

upx-ucl (3.94-2) unstable; urgency=low

  * Upload to unstable.
  * Merge changes from version 3.91-3 and 3.91-4: add Check-DT_REL-i386.patch
    and changelog entries.
  * Standards-Version: 4.0.1.

 -- Robert Luberda <robert@debian.org>  Wed, 09 Aug 2017 22:59:28 +0200

upx-ucl (3.94-1) experimental; urgency=low

  * New upstream version.
  * Remove no longer needed 02-FTBFS-GCC7.patch.
  * debian/rules: Add sparc64 to big-endian archs to hopefully fix FTBFS.

 -- Robert Luberda <robert@debian.org>  Thu, 18 May 2017 00:00:53 +0200

upx-ucl (3.93-1) experimental; urgency=low

  * New upstream version:
    + contains fixes for failed assertions (closes: #775451) and segmentation
      fault (closes: #775455).
  * Upstream homepage was moved to github, update URLs in debian/watch,
    debian/control and debian/copyright.
  * Remove 00-Makefile.patch; override a few upstream Makefile's variables
    in debian/rules instead.
  * Remove 02-Lzma-support.patch together with build-dependency on lzma-dev
    and Built-Using control field. Now upx is built with lzma sources included
    by upstream in the upx source package.
  * Drop 03-FTBFS-GCC6.patch, applied by upstream.
  * Add 02-FTBFS-GCC7.patch that fixes the implicit fallthrough error reported
    by g++-7 (closes: #853694; all other issues mentioned in the bug seem to
    be fixed by upstream).
  * Bump debhelper's compat level to 10.
  * Update debian/copyright with lzma-sdk license details.

 -- Robert Luberda <robert@debian.org>  Fri, 21 Apr 2017 23:08:52 +0200

upx-ucl (3.91-4) unstable; urgency=medium

  * Introduce Check-DT_REL-i386.patch to fix segmentation faults occurring
    while executing upx-compressed i386 position-independent binaries. The
    patch is strongly based on the one added previously for amd64 binaries,
    and was reported to upstream in https://github.com/upx/upx/issues/106.

 -- Robert Luberda <robert@debian.org>  Wed, 31 May 2017 21:50:25 +0200

upx-ucl (3.91-3) unstable; urgency=medium

  * Add Check-DT_RELA.patch based on upstream's commit d688a05ac7 to
    fix segmentation faults on decompressing executables produced by
    newer binutils on amd64 (closes: #860953).
  * Apply the following packaging changes from 3.94-1 in Debian/experimental:
    + upstream homepage was moved to github, update URLs in debian/watch,
      debian/control and debian/copyright;
    + debian/rules: Add sparc64 to big-endian archs to fix FTBFS.

 -- Robert Luberda <robert@debian.org>  Sat, 20 May 2017 09:17:12 +0200

upx-ucl (3.91-2) unstable; urgency=medium

  * Add 03-FTBFS-GCC6.patch to fix build failure with g++-6 (closes: #811595).
  * debian/rules: Enable all hardening options.
  * debian/copyright: Switch to the DEP-5 format.
  * debian/control:
    + switch VCS fields to https;
    + bump Standards-Version to 3.9.8 (no changes).

 -- Robert Luberda <robert@debian.org>  Sun, 03 Jul 2016 13:02:47 +0200

=== debian/control ===
Source: upx-ucl
Section: utils
Priority: optional
Maintainer: Robert Luberda <robert@debian.org>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 10),
               libucl-dev (>= 1.03),
               zlib1g-dev (>= 1:1.1.4)
Homepage: https://upx.github.io/
Vcs-Git: https://anonscm.debian.org/git/users/robert/upx-ucl.git
Vcs-Browser: https://anonscm.debian.org/cgit/users/robert/upx-ucl.git

Package: upx-ucl
Architecture: any
Provides: upx
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: efficient live-compressor for executables
 UPX is an advanced executable file compressor. UPX will typically
 reduce the file size of programs and DLLs by around 50%-70%, thus
 reducing disk space, network load times, download times etc. The
 current version can compress executables for DOS, Linux/ELF (i386,
 amd64, ppc32) and some other files for different OS.
 .
 NOTE: This package is based on the UCL library, which is licensed under GPL.

=== debian/rules ===
#!/usr/bin/make -f

DH_AUTO_OPTIONS         := -v -Smakefile --parallel
package                 := $(shell dh_listpackages)


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DESTDIR          := $(CURDIR)/debian/$(package)

export UPX_UCLDIR       := /none
export UPX_LZMADIR      := /usr/include/lzma
export CXXFLAGS         := $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS         := -DWITH_UCL -D_FILE_OFFSET_BITS=64 \
                           $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS          := $(shell dpkg-buildflags --get LDFLAGS)
ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
        CPPFLAGS        += -D__BIG_ENDIAN__=1
endif

%:
	dh "$@"

override_dh_auto_build:
	# Add here commands to compile the package.
	@echo "Starting build process ($(DEB_HOST_ARCH))"
	dh_auto_build $(DH_AUTO_OPTIONS) --     \
		      CXXFLAGS_OPTIMIZE=        \
		      CHECK_WHITESPACE=         \
		      UPX_VERSION_GITREV=       \
	              exeext=                   \
	              target=linux              \
	              all

	cd doc && mv upx.1 $(package).1

override_dh_auto_clean:
	dh_auto_clean $(DH_AUTO_OPTIONS) -- \
	                exeext=
	rm -rf doc/*.1 doc/*.ps

override_dh_auto_install:
	install -pm 0755 src/upx $(DESTDIR)/usr/bin/$(package)

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installman:
	dh_installman doc/*.1

## upx-ucl 3.95

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # UPX toplevel Makefile - needs GNU make 3.81 or better
 #
-# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2018 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # UPX Makefile - needs GNU make 3.81 or better
 #
-# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2018 Markus Franz Xaver Johannes Oberhumer
 #
 
 # build configuration options for this Makefile
@@ -163,11 +163,11 @@
 
 # automatically format some C++ source code files
 ifeq ($(shell uname),Linux)
-CLANG_FORMAT_FILES += linker.cpp linker.h packhead.cpp packmast.cpp
+CLANG_FORMAT_FILES += linker.cpp linker.h packhead.cpp packmast.cpp packmast.h
 CLANG_FORMAT_FILES += s_djgpp2.cpp s_object.cpp s_vcsa.cpp s_win32.cpp screen.h
 CLANG_FORMAT_FILES += snprintf.cpp
 CLANG_FORMAT_FILES += stdcxx.cpp stdcxx.h
-CLANG_FORMAT_FILES += ui.cpp ui.h util.h
+CLANG_FORMAT_FILES += ui.cpp ui.h util.cpp util.h work.cpp
 clang-format:
 	$(top_srcdir)/src/stub/scripts/upx-clang-format -i $(addprefix $(top_srcdir)/src/,$(CLANG_FORMAT_FILES))
 .PHONY: clang-format

=== src/stub/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # cross-assemblers and cross-compilers - please see README.SRC
 # for details.
 #
-# Copyright (C) 1996-2017 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2018 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR
@@ -117,8 +117,10 @@
 STUBS += m68k-atari.tos.h
 STUBS += mips.r3000-linux.elf-entry.h
 STUBS += mips.r3000-linux.elf-fold.h
+STUBS += mips.r3000-linux.shlib-init.h
 STUBS += mipsel.r3000-linux.elf-entry.h
 STUBS += mipsel.r3000-linux.elf-fold.h
+STUBS += mipsel.r3000-linux.shlib-init.h
 STUBS += mipsel.r3000-ps1.h
 STUBS += powerpc-darwin.dylib-entry.h
 STUBS += powerpc-darwin.macho-entry.h
@@ -135,6 +137,13 @@
 STUBS += powerpc64le-linux.elf-fold.h
 STUBS += powerpc64le-linux.kernel.vmlinux-head.h
 STUBS += powerpc64le-linux.kernel.vmlinux.h
+#STUBS += powerpc64-darwin.dylib-entry.h
+#STUBS += powerpc64-darwin.macho-entry.h
+#STUBS += powerpc64-darwin.macho-fold.h
+STUBS += powerpc64-linux.elf-entry.h
+STUBS += powerpc64-linux.elf-fold.h
+#STUBS += powerpc64-linux.kernel.vmlinux-head.h
+#STUBS += powerpc64-linux.kernel.vmlinux.h
 endif
 
 
@@ -332,10 +341,3 @@
 # // amd64-linux.elf
 # ************************************************************************/
 
-amd64-linux.elf%.h : tc_list = amd64-linux.elf default
-amd64-linux.elf%.h : tc_bfdname = elf64-x86-64
-
-tc.amd64-linux.elf.gcc  = amd64-linux-gcc-3.4.4 -m64 -nostdinc -MMD -MT $@
-tc.amd64-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
-tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror
-

=== debian/changelog ===
upx-ucl (3.95-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 17:01:44 +0100

upx-ucl (3.95-2) unstable; urgency=medium

  * Add two new patches, namely 02-Ignore-malformed-ElfXX_Shdr.patch, and
    03-Malformed-input.patch, taken from upstream to fix CVE-2019-14295,
    and CVE-2019-14296 (closes: #933232).
  * Add autopkgtest check for the above bug fix.
  * Bump debhelper's compat version to 12.
  * debian/rules: Use DPKG_*_MAINT_APPEND variables and buildflags.mk
    to setup build flags.
  * Standards-Version: 4.4.0.

 -- Robert Luberda <robert@debian.org>  Mon, 29 Jul 2019 21:10:27 +0200

upx-ucl (3.95-1) unstable; urgency=medium

  * New upstream version:
    + contains fix for multiple memory reading issue (CVE-2018-11243,
      closes: #899190).
  * Add autopkgtest checks for basic functionalities of upx and for
    regressions against a few bugs reported in Debian in last few years.
  * Upload to unstable.
  * Standards-Version: 4.2.1.

 -- Robert Luberda <robert@debian.org>  Tue, 28 Aug 2018 21:47:27 +0200

upx-ucl (3.95~git20180805-1) experimental; urgency=medium

  * New upstream snapshot from git commit b97688d11.
  * Merge changes from 3.94-5 (switch to debhelper v11, update Vcs-*,
    and Standards-Version fields).

 -- Robert Luberda <robert@debian.org>  Sun, 05 Aug 2018 13:10:55 +0200

upx-ucl (3.94+git20171222-1) experimental; urgency=medium

  * New upstream snapshot from git commit aefb2fa3c.
  * Merge changes from 3.94-3 and 3.94-4, but remove both patches added
    in the latter version, as they are already included in this upstream
    snaphot.
  * debian/control: set Rules-Requires-Root to "no".

 -- Robert Luberda <robert@debian.org>  Sat, 23 Dec 2017 00:33:34 +0100

upx-ucl (3.94+git20170810-1) experimental; urgency=low

  * New upstream snapshot from git commit 5b545444 that hopefully fixes
    FTBFS on i386 and other architectures.

 -- Robert Luberda <robert@debian.org>  Thu, 10 Aug 2017 22:58:01 +0200

upx-ucl (3.94+git20170809-1) experimental; urgency=low

  * New upstream snapshot from git commit 8f572e5f.
  * Remove no longer needed  Check-DT_REL-i386.patch.

 -- Robert Luberda <robert@debian.org>  Wed, 09 Aug 2017 23:47:19 +0200

upx-ucl (3.94-5) unstable; urgency=medium

  * Apply Silence-some-gcc-8-snapshot-compiler-warnings.patch from upstream
    to fix gcc-8 compilation failure (closes: #897880).
  * Bump debhelper's compat level to 11.
  * debian/control:
    + update Vcs-* fields for salsa migration;
    + add `Rules-Requires-Root: no' field;
    + Standards-Version: 4.2.0.

 -- Robert Luberda <robert@debian.org>  Sun, 05 Aug 2018 08:55:46 +0200

=== debian/control ===
Source: upx-ucl
Section: utils
Priority: optional
Maintainer: Robert Luberda <robert@debian.org>
Standards-Version: 4.4.0
Build-Depends: debhelper (>= 12), libucl-dev (>= 1.03), zlib1g-dev (>= 1:1.1.4)
Homepage: https://upx.github.io/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/upx-ucl.git
Vcs-Browser: https://salsa.debian.org/debian/upx-ucl/

Package: upx-ucl
Architecture: any
Provides: upx
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: efficient live-compressor for executables
 UPX is an advanced executable file compressor. UPX will typically
 reduce the file size of programs and DLLs by around 50%-70%, thus
 reducing disk space, network load times, download times etc. The
 current version can compress executables for DOS, Linux/ELF (i386,
 amd64, ppc32) and some other files for different OS.
 .
 NOTE: This package is based on the UCL library, which is licensed under GPL.

=== debian/tests/control ===
Tests: basic-check

Test-Command: ./debian/tests/regressions-check 775451-assert149.elf "UnknownExecutableFormatException"
Features: test-name=bug775451-check1

Test-Command: ./debian/tests/regressions-check 775451-assert150.elf "UnknownExecutableFormatException"
Features: test-name=bug775451-check2

Test-Command: ./debian/tests/regressions-check 775455-crash.elf "UnknownExecutableFormatException"
Features: test-name=bug775455-check

Test-Command: ./debian/tests/regressions-check 873260-crash.upx "CantPackException: bad e_phoff"
Features: test-name=bug873260-check

Test-Command: ./debian/tests/regressions-check 882401-segfault-macho "CantPackException: bad Mach_command"
Features: test-name=bug882401-check

Test-Command: ./debian/tests/regressions-check 899190-poc1 "CantPackException: bad PT_DYNAMIC"
Features: test-name=bug899190-check1

Test-Command: ./debian/tests/regressions-check 899190-poc2 "CantPackException: DT_STRTAB above stub"
Features: test-name=bug899190-check2

Test-Command: ./debian/tests/regressions-check -d 907426-poc_free "Exception: compressed data violation"
Features: test-name=bug907426-check
Restrictions: flaky

Test-Command: ./debian/tests/regressions-check -d 933232-poc-integer-overflow "CantUnpackException: bad e_phoff"
Features: test-name=bug933232-check1

Test-Command: ./debian/tests/regressions-check --no-qq -d 933232-poc-buffer-overflow "NotPackedException: not packed by UPX" 2
Features: test-name=bug933232-check2

## upx-ucl 3.96

=== doc/Makefile ===
--- 
+++ 
@@ -50,22 +50,28 @@
 
 %.1 : %.pod
 	pod2man --center=" " --release="$(PACKAGE) $(VERSION)" --date="$(VERSION_DATE)" $< | $(RTRIM) > $@
+	test -s $@
 
 %.doc : %.pod
 	pod2text < $< | $(RTRIM) > $@
+	test -s $@
 
 %.html : %.pod
 	pod2html --noindex $< | $(RTRIM) | $(DETAB2) > $@
 	@rm -f pod2htm*
+	test -s $@
 
 %.man : %.1
 	nroff -man $< | $(RTRIM) > $@
+	test -s $@
 
 %.ps : %.1
 	groff -man $< | $(RTRIM) > $@
+	test -s $@
 
 %.tex : %.pod
 	pod2latex $<
+	test -s $@
 
 
 ###

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # UPX Makefile - needs GNU make 3.81 or better
 #
-# Copyright (C) 1996-2018 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2020 Markus Franz Xaver Johannes Oberhumer
 #
 
 # build configuration options for this Makefile
@@ -148,7 +148,7 @@
 endif
 endif
 # run the UPX testsuite
-# The expected (old) checksums are in $(top_srcdir)/.github/travis_testsuite_1.sh
+# The expected (old) checksums are in $(top_srcdir)/.github/travis_testsuite_1-expected_sha256sums.sh
 # The   actual (new) checksums are in tmp-testsuite/testsuite_1/.sha256sums.recreate
 ifneq ($(wildcard $(upx_testsuite_SRCDIR)/files/packed/.),)
 ifneq ($(wildcard $(top_srcdir)/.github/travis_testsuite_1.sh),)

=== src/stub/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # cross-assemblers and cross-compilers - please see README.SRC
 # for details.
 #
-# Copyright (C) 1996-2018 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2020 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR

=== src/stub/tools/armpe/Makefile ===
#  Makefile for armpe_tester

MAKEFLAGS += -rR
.SUFFIXES:
.SECONDEXPANSION:
.NOTPARALLEL:
export LC_ALL = C
export SHELL = /bin/sh

# update $PATH for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
else ifneq ($(wildcard $(HOME)/.local/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/.local/bin/bin-upx:$(PATH)
else ifneq ($(wildcard $(HOME)/bin/bin-upx/upx-stubtools-check-version),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif

CFLAGS_W = -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings


all: armpe_tester.out
#all: armpe_tester.exe

armpe_tester.out: armpe_tester.c $(MAKEFILE_LIST)
	arm-linux-gnueabi-gcc -static $(CFLAGS_W) -o $@ $<

armpe_tester.exe: armpe_tester.c $(MAKEFILE_LIST)
	arm-wince-pe-gcc -Wl,--image-base,0x400000 -s $(CFLAGS_W) -o $@ $<

mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.o *.obj
	rm -f armpe_tester.exe armpe_tester.out

.PHONY: all mostlyclean clean distclean maintainer-clean

=== src/stub/src/arch/amd64/Makefile ===
# convenience Makefile
default %:
	$(MAKE) -C ../../.. $@

=== src/stub/src/arch/arm/v4a/Makefile ===
# convenience Makefile
default %:
	$(MAKE) -C ../../../.. $@

=== debian/changelog ===
upx-ucl (3.96-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Submit.
  * Update standards version to 4.5.1, no changes needed.

  [ Robert Luberda ]
  * Add 03-upstream-silence-compilation-warnings.patch from upstream's
    commit c6c2fc49e to fix FTBFS with new gcc (closes: #984379).
  * Add debian/source/lintan-overrides for binaries included in
    debian/test/data for autopkgtest purposes.
  * Fix a typo in debian/copyright (lintian).
  * Remove Homepage field from debian/upstream/metadata (lintian).
  * Update standards version to 4.6.0, no changes needed.

 -- Robert Luberda <robert@debian.org>  Thu, 14 Oct 2021 08:12:34 +0200

upx-ucl (3.96-2) unstable; urgency=medium

  * Add 02-arm64-crashes.patch that reverts one of upstream commits, what should
    fix crashes visible on arm64 (closes: #955157).
  * Bump debhelper's compat version to 13.

 -- Robert Luberda <robert@debian.org>  Fri, 05 Jun 2020 12:14:39 +0200

upx-ucl (3.96-1) unstable; urgency=medium

  * New upstream version:
    + fixes heap-based buffer over-read and invalid memory address dereference
      in canUnpack()  (CVE-2019-20021, CVE-2019-20053, closes: #947471).
  * Remove no longer needed patches: 02-Ignore-malformed-ElfXX_Shdr.patch,
    and 03-Malformed-input.patch.
  * Add autopkgtest checks for #947471.
  * Replace debian/compat with build-dependency on debhelper-compat.
  * Add upstream metadata file.
  * Standards-Version: 4.5.0.

 -- Robert Luberda <robert@debian.org>  Sun, 08 Mar 2020 13:48:26 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 12), libucl-dev (>= 1.03), zlib1g-dev (>= 1:1.1.4)
+Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), libucl-dev (>= 1.03), zlib1g-dev (>= 1:1.1.4)
 Homepage: https://upx.github.io/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/upx-ucl.git

=== debian/rules ===
#!/usr/bin/make -f

DH_AUTO_OPTIONS         := -v -Smakefile --parallel
package                 := $(shell dh_listpackages)
export DESTDIR          := $(CURDIR)/debian/$(package)
export UPX_UCLDIR       := /none
export UPX_LZMADIR      := /usr/include/lzma

include /usr/share/dpkg/architecture.mk

DEB_BUILD_MAINT_OPTIONS     := hardening=+all
DEB_CPPFLAGS_MAINT_APPEND   := -DWITH_UCL -D_FILE_OFFSET_BITS=64
ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
  DEB_CPPFLAGS_MAINT_APPEND += -D__BIG_ENDIAN__=1
endif

DPKG_EXPORT_BUILDFLAGS  := 1
include /usr/share/dpkg/buildflags.mk

%:
	dh "$@"

override_dh_auto_build:
	@echo "Starting build process ($(DEB_HOST_ARCH))"
	dh_auto_build $(DH_AUTO_OPTIONS) --     \
		      CXXFLAGS_OPTIMIZE=        \
		      CHECK_WHITESPACE=         \
		      UPX_VERSION_GITREV=       \
	              exeext=                   \
	              target=linux              \
	              all

	cd doc && mv upx.1 $(package).1

override_dh_auto_clean:
	dh_auto_clean $(DH_AUTO_OPTIONS) -- \
	                exeext=
	rm -rf doc/*.1 doc/*.ps

override_dh_auto_install:
	install -pm 0755 src/upx $(DESTDIR)/usr/bin/$(package)

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installman:
	dh_installman doc/*.1

=== debian/tests/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Test-Command: ./debian/tests/regressions-check 882401-segfault-macho "CantPackException: bad Mach_command"
 Features: test-name=bug882401-check
 
-Test-Command: ./debian/tests/regressions-check 899190-poc1 "CantPackException: bad PT_DYNAMIC"
+Test-Command: ./debian/tests/regressions-check 899190-poc1 'CantPackException: need DT_INIT; try "void _init(void){}"'
 Features: test-name=bug899190-check1
 
 Test-Command: ./debian/tests/regressions-check 899190-poc2 "CantPackException: DT_STRTAB above stub"
@@ -23,10 +23,17 @@
 
 Test-Command: ./debian/tests/regressions-check -d 907426-poc_free "Exception: compressed data violation"
 Features: test-name=bug907426-check
-Restrictions: flaky
 
 Test-Command: ./debian/tests/regressions-check -d 933232-poc-integer-overflow "CantUnpackException: bad e_phoff"
 Features: test-name=bug933232-check1
 
 Test-Command: ./debian/tests/regressions-check --no-qq -d 933232-poc-buffer-overflow "NotPackedException: not packed by UPX" 2
 Features: test-name=bug933232-check2
+
+# Data file downloaded from https://github.com/upx/upx/issues/314
+Test-Command: ./debian/tests/regressions-check -d 947471-poc1 "CantUnpackException: file corrupted"
+Features: test-name=bug947471-check1
+
+# Data file downloaded from https://github.com/upx/upx/issues/315
+Test-Command: ./debian/tests/regressions-check -d 947471-poc2 "CantUnpackException: file corrupted"
+Features: test-name=bug947471-check2
